#ifndef EFL_ORIENTATION_EO_HH
#define EFL_ORIENTATION_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_orientation.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Orientation;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Orientation> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Orientation {
   ::efl::eolian::return_traits<Efl_Orient>::type orientation_get() const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_ORIENTATION_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Orientation() const;
   operator ::efl::Orientation&();
   operator ::efl::Orientation const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Orientation> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Orientation const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Orientation : ::efl::eo::concrete
{
   explicit Orientation( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Orientation(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Orientation(Orientation const& other) = default;
   Orientation(Orientation&& other) = default;
   Orientation& operator=(Orientation const& other) = default;
   Orientation& operator=(Orientation&& other) = default;
   Orientation()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Orientation( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Orientation(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<Efl_Orient>::type orientation_get() const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_ORIENTATION_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Orientation> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Orientation const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Orientation) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Orientation>::value, "");
} 
#include "efl_orientation.eo.impl.hh"
#endif
